
	SUBROUTINE gmcode(ns,xs0,ys0,xe0,ye0,sw0,td,ysize,
     &        title,output1,output2)

	CHARACTER title*(*)

	CHARACTER output1*(*)
	CHARACTER output2*(*)
        integer ns
	REAL  XS0(ns),YS0(ns),XE0(ns),YE0(ns),SW0(ns)
        real xs(ns),ys(ns),xe(ns),ye(ns),sw(ns)
c
c Put slit dimensions in inches, transform to GMC x-direction and 
c order with increasing x(GMC)
c

        scalein = 1.0/(25.4)  ! inches per mm

        do i = 1,ns
           j = ns - i + 1
           xs(i) = -xs0(j) * scalein
           ys(i) =  ys0(j) * scalein
           xe(i) = -xe0(j) * scalein
           ye(i) =  ye0(j) * scalein
           sw(i) =  sw0(j) * scalein
c           sw(i) =  wproj(j) * scalein

c
c
c check for slit falling off edge of mask
c
 
           if (ye(i).gt.0.5*ysize*scalein) then
              dxdy = (xe(i)-xs(i))/(ye(i)-ys(i))
              dye   =  ye(i) - 0.5 * ysize * scalein
              xe(i) = xe(i) - dye * dxdy
              ye(i) = 0.5*ysize * scalein
           endif


           if (ys(i).lt.-0.5*ysize*scalein) then
              dxdy = (xe(i)-xs(i))/(ye(i)-ys(i))
              dys   = ys(i) + 0.5*ysize * scalein 
              xs(i) = xs(i) + dys * dxdy
              ys(i) = - 0.5*ysize * scalein 
           endif
           
        enddo
c
c re-order slits/holes for efficient milling path
c
        call short_path(xs,ys,xe,ye,sw,ns)

	call gmcode_2p(ns,xs,ys,xe,ye,sw,td,
     &        title,output1,output2)

	return
	end



C************************************************************************

C  NOTE***
C
C Temporary version to take the 0.007 inch endmill to do hole cutting
C

	SUBROUTINE gmcode_2p(ns,xs,ys,xe,ye,sw,td,title,output1,output2)

c	written by Barbara L. Weymann and Ray Weymann

c	this file in: /home/mozart/rjw/rjwadm/ociw/fpcam/cur_softw/slits/gmcode_2p.f
c	revision: Feb.  13th 1999
c	this code is being modified to make two single passes: one with the
c	0.020 or 0.025  end mill and the second pass with the engraving tool. 
C	LAST REVISION Feb. 13, 1999
c       modified by S. C. Trager, 3/3/99, to include tilted slits
c       modified by A.McWilliam 18,March,1999 for subroutine version and tilted slits



C  This program creates an ASCII text file in the code
C  used for the computer that runs the machine that cuts
C  rectangular slits (including
c  alignment star squares, for the masks.
c	          ... Zero point located
c			... at the TOP SURFACE of slitmask blank
c			... at the center of the mask.

c	INPUTS FROM THE TERMINAL:
c       1) The name of the output file:
c	
c       2) The user may change end-mill diameter and default distances.
c		
c	Defaults are: metal blank thickness 0.012, engraving tool tip 0.003
c		angle is  2:1

c	All these dimensions are in INCHES. If sl <= 0.001 a round aperture
c	... of diameter sw is made, at position xs, ys. If sl > 0.001 a 
c	... slit is made whose STARTING position is xs, ys and whose ENDING
c       ... position is xe, ye.  This allows for tilted slits.
c	... origin 0.0, 0.0 is at center of mask
c	...>>>>>> NOTE NOTE NOTE: these x co-coordinates increase to the RIGHT
c	...and these y coordinates increase AWAY from the operater as the mask
c	...is mounted 		
c   TD   is the tool diameter
c 
c	INTEGER LINE,NPOINTS,NSWEEPS,NZIGZAGS,I,IFILE  
 
        real*8 kmax
        parameter(kmax=1e38)
        integer ns
	REAL*4  XS(ns),YS(ns),XE(ns),YE(ns),SW(ns),td

	CHARACTER title*(*)

	CHARACTER output1*(*)
	CHARACTER output2*(*)
c
c default milling parameters
c
	ZMETAL = 0.012
	TIP   =  0.003
	ENDMILLD = 0.020
	UNCUT  = 0.003
c       ZSAFE  = 0.100
        ZSAFE  = 0.010
	ZSTART = 0.003    !may want to change zstart to 0.005


	ZENDMILL = ZMETAL - UNCUT 

C       ...Open output file


c single pass mode for all but 0.010 slits, as the 0.010 milling tool is too short.

        if (td.gt.0.011) then
           open(unit=20,file=output1,status='unknown')

c write header information to GM code file(s)

	   write(20,'(a,a)')   '( ', title
           write(20,'(a,f5.3,a)') '( Single pass mode: ',td,
     &           ' inch small milling tool'
           write(20,'(a)') 'G4 F 15'    ! pause for 15 seconds before 1st commands...
           write(20,'(a)') 'G98 G70'
           write(20,'(a)') 'G90'
           write(20,'(a)') 'G00'
           write(20,'(a)') 'M03 M07'
           write(20,'(a)') 'F 1.5 E0.1875'  ! note the Z motion is 10% of the X-Y motion
           write(20,'(a,f5.1)') ' Z ', ZSAFE
           write(20,'(a)') 'G39 X -3.47 Y - 2.25 I 6.94 J 4.50' ! display ldss mask AMcW 02/2001

c write slit information

	   if (ns.gt.kmax) stop ' TOO MANY SLITS'
           ms = 2
	   do ks =1, ns
              call slit(xs(ks),ys(ks),xe(ks),ye(ks),sw(ks),zsafe,
     %                  zstart,zmetal,tip,td,ms,zendmill)
	   enddo
	
c move tool out of the way

	   write(20,'(a)') ' Z 0.80'
	   write(20,'(a)') ' X 2.5  Y -1.6'
	   write(20,'(a)') ' M30'
           close(20)
	else

        open(unit=20,file=output1,status='unknown')
        open(unit=30,file=output2,status='unknown')
	WRITE(20,'(a,a)')   '(', title
        WRITE(20,'(a,f5.3,a)') '( 2nd pass: ',td,
     &        ' inch small milling tool'

	WRITE(30,'(a,a)')   '(', title
	WRITE(30,'(a,f5.3,a)') '( 1st pass: ',ENDMILLD,
     &  ' ENDMILL'



c	...initialize ...for engraving tool
	WRITE(20,'(a)') 'G4 F 15'    ! pause for 15 seconds before 1st commands...
	WRITE(20,'(a)') 'G98 G70'
	WRITE(20,'(a)') 'G90'
	WRITE(20,'(a)') 'G00'
	WRITE(20,'(a)') 'M03 M07'
	WRITE(20,'(a)') 'F 1.5 E0.1875'  ! note the Z motion is 10% of the X-Y motion
	WRITE(20,'(a,f5.1)') ' Z ', ZSAFE
c	WRITE(20,'(a)') 'G39 X -2.3 Y - 1.7 I 4.6 J 3.4' !this displays the full slit AMcW 02/2001

c now trying to accomodate the larger slit mask for LDSS 2
	WRITE(20,'(a)') 'G39 X -3.47 Y - 2.25 I 6.94 J 4.50' !                  AMcW 02/2001

c	...initialize ...for endmill
	WRITE(30,'(a)') 'G4 F 15'    ! pause for 15 seconds before 1st commands...
	WRITE(30,'(a)') 'G98 G70'
	WRITE(30,'(a)') 'G90'
	WRITE(30,'(a)') 'G00'
	WRITE(30,'(a)') 'M03 M07'
	WRITE(30,'(a)') 'F1.5 E0.375'  ! note the Z motion is 10% of the X-Y motion
	WRITE(30,'(a,f5.1)') ' Z ', ZSAFE
c       WRITE(30,'(a)') 'G39 X -2.3 Y - 1.7 I 4.6 J 3.4' ! this displays the full slit
c							   ....pattern

c now trying to accomodate the larger slit mask for LDSS 2
	WRITE(30,'(a)') 'G39 X -3.47 Y - 2.25 I 6.93 J 4.50' !                  AMcW 02/2001


      

c		...Read in array of slits parameters
c		...these should be ordered in
c		... order of increasing X
C 		...XS,YS are starting points at the left of the slit,
C 		...XE,YE are ending points at the right of the slit,
c               ... SW is the slit width, perpendicular to the direction of the slit (AMcW);
c		... x increases to the right. Note that X(servo) increase to RIGHT, whereas
c		... the photographic mask coords increase to LEFT. See the code MAKEMET.F
c
c removed input commands: AMcW 9/march/99
c

	IF(NS.GT.kmax) STOP ' TOO MANY SLITS'
	DO MS =1,2		! first pass is for endmill,
	   DO KS =1, NS
              CALL SLIT(XS(KS),YS(KS),XE(KS),YE(KS),SW(KS),ZSAFE,
     %                  ZSTART,ZMETAL,TIP,td,MS,ZENDMILL)
	   ENDDO
	ENDDO
	
c	
	WRITE(20,'(a)') ' Z 0.80'
	WRITE(20,'(a)') ' X 2.5  Y -1.6'

c       ... these last two commands move the tool out of the way,
c       ... but in practice against the limits..after the 2nd pass



	
c       ... this is the park position after the 1st pass	
	WRITE(30,'(a)') ' Z 0.80'
	WRITE(30,'(a)') ' X 0.0  Y -1.6' ! as per Oscar request




	WRITE(20,'(a)') ' M30'
	WRITE(30,'(a)') ' M30'

        close(20)
        close(30)

	endif

	RETURN
	END
C*******************************************
c       modified 3/3/99 by SCT to allow for tilted slits
c 	... this is the single new routine for
c	... the metal mask GMCODE... it incorporates 

        SUBROUTINE SLIT(XS,YS,XE,YE,SW,ZSAFE,ZSTART,ZMETAL,TIP,td,
     %              MS, ZENDMILL)


c	... MS=1: This is the 1st (endmill) pass. It writes to file 30
c	... MS=2: This is the 2nd (engraving tool) pass. It writes to file 20

c	Cuts a rectangular slit using the following sequence:
c	1) Sets ABSOLUTE and RAPID mode, and
c	positions the  the tool tip at absolute height ZSAFE above the
c	surface of the blank 
c	---->>>> note these two commands are redundant since they are also
c	the last commands in the subroutine: They are left in to insure that
c	any fiddling outside the routine doesnt cause the machine to 
c	be in the wrong mode or unsafe position. 
c	redundant for safety, since these are also the last commands
c	exiting the routine

C	... If the  SLIT LENGTH , SL is le 0.000 then a hole is made,
c	... but large holes which would require the tool depth to be
c	... under ZUNDERMAX are not allowed.

        real*4 td
	character XC*3, YC*3,ZC*3
	character G00*4, G01*4,G90*4,G91*4
	parameter(XC = 'X  ',YC= 'Y  ', ZC = 'Z  ')
	parameter(G00 = 'G00 ', G01 = 'G01 ')
	parameter(G90 = 'G90 ', G91 = 'G91 ')

	ZUNDERMAX = 0.009004   !the maximum tool depth below mask for "narrow" mode
c		... the value of ZUNDERMAX may have to be reduced to 0.008
	ZUNDERNOM = 0.003    !the nominal tool depth below mask for "wide" mode


c switch coordinate order if xe < xs      AMcW 3/99
c
c Ken Clardy pointed out that one does not want to change inputs in a subroutine
c 11/2001
c

        IF (XE.LT.XS) THEN
           XDUM = XS
           XS   = XE
           XE   = XDUM
           YDUM = YS
           YS = YE
           YE = YDUM
        ENDIF


	IF(MS.EQ.1) THEN	! ...................the endmill pass starts here .............
	   
	   
	   WRITE(30,'(a4)') G00	!  ensure in RAPID
	   WRITE(30,'(a4)') G90	!  ensure in ABSOLUTE MODE
	   WRITE(30,'(a4,f9.5)') ZC,ZSAFE !  ensure at safe height
	   WRITE(30,'(2(a4,f9.5))') XC,XS,YC,YS ! move to X,Y start position
	   WRITE(30,'(a4,f9.5)') ZC,ZSTART ! move to Z start position rapidly
	   WRITE(30,'(a4)') G01	!  switch to LINEAR (slow) mode
	   WRITE(30,'(a4)') G91	!  switch to INCREMENTAL MODE
		 
	   ZENDINC= -(ZSTART +ZENDMILL)	! the incremental zmotion for endmill
	   WRITE(30,'(a4,f9.5)') ZC,ZENDINC 

 101	   format(2(a4,f9.5))
 102	   format(a4,f9.5)

	   IF(SW.le.0.027) then ! slit is narrow enough to simply make a single cut
c       ... with no small dx, dy offsets to the depth
c       ! cut to X,Y end position
        
              if ( (xe-xs).ne.0.0 .or. (ye-ys).ne.0.0 ) then
	         WRITE(30,101) XC,(XE-XS),YC,(YE-YS)
              endif
c   ELSE (sw.gt.0.027) then  ( Ooops! AMcW 4/2002 )
           ELSE
c       ... large slit requires moving in a rectangular pattern... 

c  move in Y by projected slit width for tilted slits AMcW 3/99

              SWP = SW * SQRT( ((YE-YS)/(XE-XS))**2 + 1.0 )
              HSWP = 0.5*SWP
c             HSW = 0.5*SW         ! ...half the slit width deleted AMcW 3/99
	      WRITE(30,102) YC,HSWP ! from start to top left
	      WRITE(30,101) XC,(XE-XS),YC,(YE-YS) ! from top left to top right
	      WRITE(30,102) YC,-SWP ! from top right to bottom right
C       from bottom right to bottom left
	      WRITE(30,101) XC,-(XE-XS),YC,-(YE-YS)
	      WRITE(30,102) YC,HSWP ! from bottom left back to start 
	   ENDIF		! end if for narrow vs. wide
	   WRITE(30,'(a4)') G00	!  change to RAPID MODE
	   WRITE(30,'(a4)') G90	!  change to ABSOLUTE MODE
	   WRITE(30,102) ZC,ZSAFE !  move to safe height


	ELSE IF(MS.EQ.2) THEN	!  the 2nd pass with the engraving tool

c	... first calculate the incremental moves and decide between
c	... "narrow" or "wide" case:

c	... calculate the depth below the surface assuming narrow mode:
c          ZUNDER = 2*(SW - TIP) 
c
c This code should enable milling-tool cutting of the slits/holes AMcW 19/May/00
c code for deciding narrow or wide mode for cutting slits
c
           if (sw.le.0.0273) then
              knw = 1
           else
              knw = 2
           endif
           zunder = zundernom
           rad = 0.5 * td
c
	   DX =     RAD		! shift the start of the cut so that edge of
c       cut is at XS
           XL   = XE-XS
 	   XCUT = XL -2.0*DX	! total length of cut in x direction so that
c       ... total slit length is ~ XL
	   WRITE(20,'(a4)') G00	!  ensure in RAPID
	   WRITE(20,'(a4)') G90	!  ensure in ABSOLUTE MODE
	   WRITE(20,102) ZC,ZSAFE !  ensure at safe height
           WRITE(20,101) XC,XS,YC,YS ! move to X,Y start position
	   
	   ZSTART2 = ZSTART - ZENDMILL ! this is the absolute coordinate
c       ....  starting position for the
c       ... engraving mill pass, which is lower than
c       ... ZSTART by the amount by
c       ... which the endmill has taken out
c       ... the sides of the
c       ... engraving tool should clear
	   ZBELOW = -(ZMETAL + ZUNDER) !... the signed value at the bottom.
c          ZINC   =  ZBELOW - ZSTART2 !... the (negative) incremental Z motion
	   
c
c if td > 0.011 we are in single pass mode, so move quickly to just above the metal,
c otherwise quick move into the trench
c
           if (td.gt.0.011) then
	      write(20,'(a4,f9.5)') ZC,ZSTART ! move to Z start position rapidly
	      ZINC   =  ZBELOW - ZSTART !... the (negative) incremental Z motion
           else
	      WRITE(20,'(a4,f9.5)') ZC,ZSTART2 ! move to Z start position rapidly
	      ZINC   =  ZBELOW - ZSTART2 !... the (negative) incremental Z motion
           endif
c

	   WRITE(20,'(a4)') G01	!  switch to LINEAR (slow) mode
	   WRITE(20,'(a4)') G91	!  switch to INCREMENTAL MODE

           DDY = (YE-YS)*DX/XL  !  change in Y position due to DX shift (to keep PA)


	   IF(KNW.EQ.1) THEN	!        narrow mode

              if (dx.ne.0.0 .or. ddy.ne.0.0) then
	         WRITE(20,101) XC,DX,YC,DDY ! move off start position by DX and DDY
              endif
	      WRITE(20,102) ZC,ZINC !  cut  to final zdepth
c             IF (XCUT.NE.0.0 .OR. (YE-YS-2.*DDY).NE.0.0) THEN   ! if not a hole
              IF (ABS(XCUT).GE.0.000001 .OR.
     %                     ABS(YE-YS-2.*DDY).GE.0.000001) THEN   ! if not a hole
c             IF ( XCUT**2+(YE-YS-2.*DDY)**2 .NE. 0.0 ) THEN   ! if not a hole
	         WRITE(20,101) XC,XCUT,YC,(YE-YS-2.*DDY) !  cut to end of slit
              ENDIF

	   ELSE IF(KNW.EQ.2) THEN !  box mode

c       the total increment in Y necessary to get the desired
c       slit width
              SWP = SW * SQRT( ((YE-YS)/(XE-XS))**2 + 1.0 )
	      DY = SWP - 2.0*RAD	
c             DY = SW - 2*RAD    ! replaced with above code AMcW 3/99
	      IF(DY.LT.0)
     1          STOP ' negative DY should not occur in subroutine SLIT'
	      DY2 = 0.5*DY	 ! half DY

	      WRITE(20,102) XC,DX   ! move off start position by DX 
	      WRITE(20,102) ZC,ZINC !  cut  to final zdepth
	      WRITE(20,102) YC,DY2 ! cut from center to top left
c       cut from top left to top right
	      WRITE(20,101) XC,XCUT,YC,(YE-YS-2.*DDY)
	      WRITE(20,102) YC,-DY !    cut from top right to bottom right
c       cut from bottom right to bottom left
	      WRITE(20,101) XC,-XCUT,YC,-(YE-YS-2.*DDY)
	      WRITE(20,102) YC,DY2 !    cut from bottom left to start
	   ENDIF		! endif for narrow/wide engraving tool
c	... return to ABSOLUTE and RAPID move
c	... and lift tool to safe Z height

	   WRITE(20,'(a4)') G00	!  change to RAPID MODE
	   WRITE(20,'(a4)') G90	!  change to ABSOLUTE MODE
	   WRITE(20,102) ZC,ZSAFE !  move to safe height
	   
	ENDIF			! ms enddo

	RETURN
	END
C************************************************************************
c
c  Now Numerical Recipes code for Travelling Salesman problem
c
      SUBROUTINE anneal(x,y,iorder,ncity)
      INTEGER ncity,iorder(4000)
      REAL x(4000),y(4000)
CU    USES irbit1,metrop,ran3,revcst,revers,trncst,trnspt
      INTEGER i,i1,i2,idec,idum,iseed,j,k,nlimit,nn,nover,nsucc,n(6),
     *irbit1
      REAL de,path,t,tfactr,ran3,alen,x1,x2,y1,y2
      LOGICAL ans
      alen(x1,x2,y1,y2)=sqrt((x2-x1)**2+(y2-y1)**2)
      nover=100*ncity
      nlimit=10*ncity
      tfactr=0.9
      path=0.0
      t=0.5
      write(*,*)'Wait for solution to traveling salesman problem...'
      do 11 i=1,ncity-1
        i1=iorder(i)
        i2=iorder(i+1)
        path=path+alen(x(i1),x(i2),y(i1),y(i2))
11    continue
      i1=iorder(ncity)
      i2=iorder(1)
      path=path+alen(x(i1),x(i2),y(i1),y(i2))
      idum=-1
      iseed=111
      do 13 j=1,100
        nsucc=0
        do 12 k=1,nover
1         n(1)=1+int(ncity*ran3(idum))
          n(2)=1+int((ncity-1)*ran3(idum))
          if (n(2).ge.n(1)) n(2)=n(2)+1
          nn=1+mod((n(1)-n(2)+ncity-1),ncity)
          if (nn.lt.3) goto 1
          idec=irbit1(iseed)
          if (idec.eq.0) then
            n(3)=n(2)+int(abs(nn-2)*ran3(idum))+1
            n(3)=1+mod(n(3)-1,ncity)
            call trncst(x,y,iorder,ncity,n,de)
            call metrop(de,t,ans)
            if (ans) then
              nsucc=nsucc+1
              path=path+de
              call trnspt(iorder,ncity,n)
            endif
          else
            call revcst(x,y,iorder,ncity,n,de)
            call metrop(de,t,ans)
            if (ans) then
              nsucc=nsucc+1
              path=path+de
              call revers(iorder,ncity,n)
            endif
          endif
          if (nsucc.ge.nlimit) goto 2
12      continue
2       continue
c 2     write(*,*)
c       write(*,*) 'T =',t,' Path Length =',path
c       write(*,*) 'Successful Moves: ',nsucc
        t=t*tfactr
        if (nsucc.eq.0) return
13    continue
      return
      END
      SUBROUTINE revcst(x,y,iorder,ncity,n,de)
      INTEGER ncity,iorder(4000),n(6)
      REAL de,x(4000),y(4000)
      INTEGER ii,j
      REAL alen,xx(4),yy(4),x1,x2,y1,y2
      alen(x1,x2,y1,y2)=sqrt((x2-x1)**2+(y2-y1)**2)
      n(3)=1+mod((n(1)+ncity-2),ncity)
      n(4)=1+mod(n(2),ncity)
      do 11 j=1,4
        ii=iorder(n(j))
        xx(j)=x(ii)
        yy(j)=y(ii)
11    continue
      de=-alen(xx(1),xx(3),yy(1),yy(3))-alen(xx(2),xx(4),yy(2),yy(4))+
     *alen(xx(1),xx(4),yy(1),yy(4))+alen(xx(2),xx(3),yy(2),yy(3))
      return
      END
      SUBROUTINE revers(iorder,ncity,n)
      INTEGER ncity,iorder(4000),n(6)
      INTEGER itmp,j,k,l,nn
      nn=(1+mod(n(2)-n(1)+ncity,ncity))/2
      do 11 j=1,nn
        k=1+mod((n(1)+j-2),ncity)
        l=1+mod((n(2)-j+ncity),ncity)
        itmp=iorder(k)
        iorder(k)=iorder(l)
        iorder(l)=itmp
11    continue
      return
      END
      SUBROUTINE trncst(x,y,iorder, ncity,n,de)
      INTEGER ncity,iorder(4000),n(6)
      REAL de,x(4000),y(4000)
      INTEGER ii,j
      REAL xx(6),yy(6),alen,x1,x2,y1,y2
      alen(x1,x2,y1,y2)=sqrt((x2-x1)**2+(y2-y1)**2)
      n(4)=1+mod(n(3),ncity)
      n(5)=1+mod((n(1)+ncity-2),ncity)
      n(6)=1+mod(n(2),ncity)
      do 11 j=1,6
        ii=iorder(n(j))
        xx(j)=x(ii)
        yy(j)=y(ii)
11    continue
      de=-alen(xx(2),xx(6),yy(2),yy(6))-alen(xx(1),xx(5),yy(1),
     *yy(5))-alen(xx(3),xx(4),yy(3),yy(4))+alen(xx(1),xx(3),yy(1),
     *yy(3))+alen(xx(2),xx(4),yy(2),yy(4))+alen(xx(5),xx(6),yy(5),yy(6))
      return
      END
      SUBROUTINE trnspt(iorder,ncity,n)
      INTEGER ncity,iorder(4000),n(6),MXCITY
      PARAMETER (MXCITY=4000)
      INTEGER j,jj,m1,m2,m3,nn,jorder(MXCITY)
      m1=1+mod((n(2)-n(1)+ncity),ncity)
      m2=1+mod((n(5)-n(4)+ncity),ncity)
      m3=1+mod((n(3)-n(6)+ncity),ncity)
      nn=1
      do 11 j=1,m1
        jj=1+mod((j+n(1)-2),ncity)
        jorder(nn)=iorder(jj)
        nn=nn+1
11    continue
      do 12 j=1,m2
        jj=1+mod((j+n(4)-2),ncity)
        jorder(nn)=iorder(jj)
        nn=nn+1
12    continue
      do 13 j=1,m3
        jj=1+mod((j+n(6)-2),ncity)
        jorder(nn)=iorder(jj)
        nn=nn+1
13    continue
      do 14 j=1,ncity
        iorder(j)=jorder(j)
14    continue
      return
      END
      SUBROUTINE metrop(de,t,ans)
      REAL de,t
      LOGICAL ans
CU    USES ran3
      INTEGER jdum
      REAL ran3
      SAVE jdum
      DATA jdum /1/
      ans=(de.lt.0.0).or.(ran3(jdum).lt.exp(-de/t))
      return
      END
      FUNCTION ran3(idum)
      INTEGER idum
      INTEGER MBIG,MSEED,MZ
C     REAL MBIG,MSEED,MZ
      REAL ran3,FAC
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
C     PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=1./MBIG)
      INTEGER i,iff,ii,inext,inextp,k
      INTEGER mj,mk,ma(55)
C     REAL mj,mk,ma(55)
      SAVE iff,inext,inextp,ma
      DATA iff /0/
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=MSEED-iabs(idum)
        mj=mod(mj,MBIG)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.MZ)mk=mk+MBIG
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.MZ)ma(i)=ma(i)+MBIG
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.MZ)mj=mj+MBIG
      ma(inext)=mj
      ran3=mj*FAC
      return
      END
      FUNCTION irbit1(iseed)
      INTEGER irbit1,iseed,IB1,IB2,IB5,IB18
      PARAMETER (IB1=1,IB2=2,IB5=16,IB18=131072)
      LOGICAL newbit
      newbit=iand(iseed,IB18).ne.0
      if(iand(iseed,IB5).ne.0)newbit=.not.newbit
      if(iand(iseed,IB2).ne.0)newbit=.not.newbit
      if(iand(iseed,IB1).ne.0)newbit=.not.newbit
      irbit1=0
      iseed=iand(ishft(iseed,1),not(IB1))
      if(newbit)then
        irbit1=1
        iseed=ior(iseed,IB1)
      endif
      return
      END

 
        subroutine short_path(xs,ys,xe,ye,sw,kmax)

c        include 'ldss2.common.blocks'

        integer kmax
        real xs(kmax),ys(kmax),xe(kmax),ye(kmax),sw(kmax)
        real xsn(kmax),ysn(kmax),xen(kmax),yen(kmax),swn(kmax)
        integer iorder(kmax),i


c use Numerical Recipes code for optimal order

        do i = 1,kmax
           iorder(i) = i
        enddo

        call anneal(xs,ys,iorder,kmax)

c put slits/holes in right order

        do i = 1,kmax
           xsn(i) = xs(iorder(i))
           ysn(i) = ys(iorder(i))
           xen(i) = xe(iorder(i))
           yen(i) = ye(iorder(i))
           swn(i) = sw(iorder(i))
        enddo

        do i = 1,kmax
           xs(i) = xsn(i)
           ys(i) = ysn(i)
           xe(i) = xen(i)
           ye(i) = yen(i)
           sw(i) = swn(i)
        enddo

        return
        end


